Treemap / Sunburst Morph in JavaScript

Using ApexCharts with JavaScript

This Treemap / Sunburst Morph example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Shared by the vanilla-js, React and Vue builds.
//
// One dataset, two partitions of it. The sunburst reads the hierarchy; the
// treemap reads the leaves, which are the level the two views have in common.
//
// Colour carries the identity across the switch: a team keeps its colour, so
// the tile you were looking at is the arc you end up looking at. Each branch
// owns a hue and its teams are progressively lighter shades of it.
var TREE = [
  {
    data: [
      {
        x: 'Engineering',
        y: 88,
        color: '#008FFB',
        children: [
          { x: 'Platform', y: 34, color: '#008FFB' },
          { x: 'Product', y: 30, color: '#29A1FC' },
          { x: 'Data', y: 24, color: '#52B3FC' },
        ],
      },
      {
        x: 'Design',
        y: 34,
        color: '#00E396',
        children: [
          { x: 'Research', y: 12, color: '#00E396' },
          { x: 'Brand', y: 10, color: '#29E7A7' },
          { x: 'Systems', y: 12, color: '#52ECB8' },
        ],
      },
      {
        x: 'Go to market',
        y: 52,
        color: '#FEB019',
        children: [
          { x: 'Sales', y: 26, color: '#FEB019' },
          { x: 'Marketing', y: 15, color: '#FEBD3E' },
          { x: 'Support', y: 11, color: '#FEC963' },
        ],
      },
    ],
  },
]

// The leaves, flattened: a treemap has no hierarchy, so it draws the level the
// two charts share. That is also the level the morph pairs up, tile for arc.
var LEAVES = [
  {
    data: TREE[0].data.reduce(function (acc, parent) {
      return acc.concat(
        parent.children.map(function (c) {
          return { x: c.x, y: c.y }
        }),
      )
    }, []),
  },
]

// A sunburst colours per node, so its colours travel with the data above. A
// treemap colours from the palette instead, one entry per tile once
// `distributed` is on, so hand it the same colours in the same order.
var LEAF_COLORS = TREE[0].data.reduce(function (acc, parent) {
  return acc.concat(
    parent.children.map(function (c) {
      return c.color
    }),
  )
}, [])

function wirePartitionToggle(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-view]'))

  function apply(view) {
    buttons.forEach(function (b) {
      b.className = b.getAttribute('data-view') === view ? 'on' : ''
    })
    chart.updateOptions({
      chart: { type: view === 'sunburst' ? 'sunburst' : 'treemap' },
      series: view === 'sunburst' ? TREE : LEAVES,
    })
  }

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      apply(b.getAttribute('data-view'))
    })
  })
}

var options = {
  series: LEAVES,
  chart: {
    id: 'partition',
    type: 'treemap',
    width: 700,
    height: 460,
    toolbar: {
      show: false,
    },
    animations: {
      enabled: true,
      chartTypeMorph: {
        enabled: true,
        speed: 900,
      },
    },
  },
  colors: LEAF_COLORS,
  legend: {
    show: false,
  },
  dataLabels: {
    enabled: true,
    style: {
      fontSize: '12px',
    },
  },
  plotOptions: {
    treemap: {
      // One palette entry per tile, taken straight from the data above, so a
      // tile and the arc it becomes are the same colour. Shading is off because
      // it would recolour tiles by value and break that pairing.
      distributed: true,
      enableShades: false,
    },
    sunburst: {
      innerSize: '22%',
      borderRadius: 2,
      spacing: 1,
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

// TREE, LEAVES and wirePartitionToggle live in the shared head script.
wirePartitionToggle(chart)

Treemap / Sunburst Morph in React

Using ApexCharts with React

This Treemap / Sunburst Morph example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// Shared by the vanilla-js, React and Vue builds.
//
// One dataset, two partitions of it. The sunburst reads the hierarchy; the
// treemap reads the leaves, which are the level the two views have in common.
//
// Colour carries the identity across the switch: a team keeps its colour, so
// the tile you were looking at is the arc you end up looking at. Each branch
// owns a hue and its teams are progressively lighter shades of it.
var TREE = [
  {
    data: [
      {
        x: 'Engineering',
        y: 88,
        color: '#008FFB',
        children: [
          { x: 'Platform', y: 34, color: '#008FFB' },
          { x: 'Product', y: 30, color: '#29A1FC' },
          { x: 'Data', y: 24, color: '#52B3FC' },
        ],
      },
      {
        x: 'Design',
        y: 34,
        color: '#00E396',
        children: [
          { x: 'Research', y: 12, color: '#00E396' },
          { x: 'Brand', y: 10, color: '#29E7A7' },
          { x: 'Systems', y: 12, color: '#52ECB8' },
        ],
      },
      {
        x: 'Go to market',
        y: 52,
        color: '#FEB019',
        children: [
          { x: 'Sales', y: 26, color: '#FEB019' },
          { x: 'Marketing', y: 15, color: '#FEBD3E' },
          { x: 'Support', y: 11, color: '#FEC963' },
        ],
      },
    ],
  },
]

// The leaves, flattened: a treemap has no hierarchy, so it draws the level the
// two charts share. That is also the level the morph pairs up, tile for arc.
var LEAVES = [
  {
    data: TREE[0].data.reduce(function (acc, parent) {
      return acc.concat(
        parent.children.map(function (c) {
          return { x: c.x, y: c.y }
        }),
      )
    }, []),
  },
]

// A sunburst colours per node, so its colours travel with the data above. A
// treemap colours from the palette instead, one entry per tile once
// `distributed` is on, so hand it the same colours in the same order.
var LEAF_COLORS = TREE[0].data.reduce(function (acc, parent) {
  return acc.concat(
    parent.children.map(function (c) {
      return c.color
    }),
  )
}, [])

function wirePartitionToggle(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-view]'))

  function apply(view) {
    buttons.forEach(function (b) {
      b.className = b.getAttribute('data-view') === view ? 'on' : ''
    })
    chart.updateOptions({
      chart: { type: view === 'sunburst' ? 'sunburst' : 'treemap' },
      series: view === 'sunburst' ? TREE : LEAVES,
    })
  }

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      apply(b.getAttribute('data-view'))
    })
  })
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: LEAVES,
    options: {
      chart: {
        id: 'partition',
        type: 'treemap',
        width: 700,
        height: 460,
        toolbar: {
          show: false,
        },
        animations: {
          enabled: true,
          chartTypeMorph: {
            enabled: true,
            speed: 900,
          },
        },
      },
      colors: LEAF_COLORS,
      legend: {
        show: false,
      },
      dataLabels: {
        enabled: true,
        style: {
          fontSize: '12px',
        },
      },
      plotOptions: {
        treemap: {
          // One palette entry per tile, taken straight from the data above, so a
          // tile and the arc it becomes are the same colour. Shading is off because
          // it would recolour tiles by value and break that pairing.
          distributed: true,
          enableShades: false,
        },
        sunburst: {
          innerSize: '22%',
          borderRadius: 2,
          spacing: 1,
        },
      },
    },
  })

  React.useEffect(() => {
    // The react-apexcharts wrapper owns the render, so reach the live instance
    // by its chart.id before wiring the toggle.
    const timer = window.setInterval(() => {
      const chart = ApexCharts.getChartByID('partition')
      if (!chart) return
      window.clearInterval(timer)
      wirePartitionToggle(chart)
    }, 50)

    return () => window.clearInterval(timer)
  }, [])

  return (
    <div>
      <div className="wrap">
        <h1>Two views of one partition</h1>
        <p>
          A treemap tile and a sunburst arc are both exactly one mark per row,
          so switching between them is a shape change rather than a redraw: each
          rectangle unrolls into the arc that holds the same team, and back.
          Every team keeps its colour, so you can pick one and follow it across.
          The sunburst adds the level a treemap cannot show, the parent rings,
          which sweep in behind the leaves.
        </p>

        <div className="actions">
          <button data-view="treemap" className="on">
            Treemap
          </button>
          <button data-view="sunburst">Sunburst</button>
        </div>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="treemap"
              height={460}
              width={700}
            />
          </div>
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Treemap / Sunburst Morph in Vue

Using ApexCharts with Vue

This Treemap / Sunburst Morph example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Two views of one partition</h1>
      <p>
        A treemap tile and a sunburst arc are both exactly one mark per row, so
        switching between them is a shape change rather than a redraw: each
        rectangle unrolls into the arc that holds the same team, and back. Every
        team keeps its colour, so you can pick one and follow it across. The
        sunburst adds the level a treemap cannot show, the parent rings, which
        sweep in behind the leaves.
      </p>

      <div class="actions">
        <button data-view="treemap" class="on">Treemap</button>
        <button data-view="sunburst">Sunburst</button>
      </div>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="treemap"
            height="460"
            width="700"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// Shared by the vanilla-js, React and Vue builds.
//
// One dataset, two partitions of it. The sunburst reads the hierarchy; the
// treemap reads the leaves, which are the level the two views have in common.
//
// Colour carries the identity across the switch: a team keeps its colour, so
// the tile you were looking at is the arc you end up looking at. Each branch
// owns a hue and its teams are progressively lighter shades of it.
var TREE = [
  {
    data: [
      {
        x: 'Engineering',
        y: 88,
        color: '#008FFB',
        children: [
          { x: 'Platform', y: 34, color: '#008FFB' },
          { x: 'Product', y: 30, color: '#29A1FC' },
          { x: 'Data', y: 24, color: '#52B3FC' }
        ]
      },
      {
        x: 'Design',
        y: 34,
        color: '#00E396',
        children: [
          { x: 'Research', y: 12, color: '#00E396' },
          { x: 'Brand', y: 10, color: '#29E7A7' },
          { x: 'Systems', y: 12, color: '#52ECB8' }
        ]
      },
      {
        x: 'Go to market',
        y: 52,
        color: '#FEB019',
        children: [
          { x: 'Sales', y: 26, color: '#FEB019' },
          { x: 'Marketing', y: 15, color: '#FEBD3E' },
          { x: 'Support', y: 11, color: '#FEC963' }
        ]
      }
    ]
  }
]

// The leaves, flattened: a treemap has no hierarchy, so it draws the level the
// two charts share. That is also the level the morph pairs up, tile for arc.
var LEAVES = [
  {
    data: TREE[0].data.reduce(function (acc, parent) {
      return acc.concat(
        parent.children.map(function (c) {
          return { x: c.x, y: c.y }
        })
      )
    }, [])
  }
]

// A sunburst colours per node, so its colours travel with the data above. A
// treemap colours from the palette instead, one entry per tile once
// `distributed` is on, so hand it the same colours in the same order.
var LEAF_COLORS = TREE[0].data.reduce(function (acc, parent) {
  return acc.concat(
    parent.children.map(function (c) {
      return c.color
    })
  )
}, [])

function wirePartitionToggle(chart) {
  var buttons = [].slice.call(document.querySelectorAll('[data-view]'))

  function apply(view) {
    buttons.forEach(function (b) {
      b.className = b.getAttribute('data-view') === view ? 'on' : ''
    })
    chart.updateOptions({
      chart: { type: view === 'sunburst' ? 'sunburst' : 'treemap' },
      series: view === 'sunburst' ? TREE : LEAVES
    })
  }

  buttons.forEach(function (b) {
    b.addEventListener('click', function () {
      apply(b.getAttribute('data-view'))
    })
  })
}

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: LEAVES,
chartOptions: {
chart: {
  id: 'partition',
  type: 'treemap',
  width: 700,
  height: 460,
  toolbar: {
    show: false
  },
  animations: {
    enabled: true,
    chartTypeMorph: {
      enabled: true,
      speed: 900,
    },
  },
},
colors: LEAF_COLORS,
legend: {
  show: false,
},
dataLabels: {
  enabled: true,
  style: {
    fontSize: '12px',
  },
},
plotOptions: {
  treemap: {
    // One palette entry per tile, taken straight from the data above, so a
    // tile and the arc it becomes are the same colour. Shading is off because
    // it would recolour tiles by value and break that pairing.
    distributed: true,
    enableShades: false,
  },
  sunburst: {
    innerSize: '22%',
    borderRadius: 2,
    spacing: 1,
  },
},
},
partitionTimer: null,
}
},
mounted: function () {
  // The vue-apexcharts wrapper owns the render, so reach the live instance by
  // its chart.id before wiring the toggle.
  var me = this
  me.partitionTimer = window.setInterval(function () {
    var chart = ApexCharts.getChartByID('partition')
    if (!chart) return
    window.clearInterval(me.partitionTimer)
    wirePartitionToggle(chart)
  }, 50)
},
beforeDestroy: function () {
  window.clearInterval(this.partitionTimer)
},,
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 780px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.actions {
  margin: 20px auto 12px;
  display: flex;
  gap: 8px;
  justify-content: center;
}
.actions button {
  color: #5b6b78;
  background: #fff;
  border: 1px solid #dfe6ec;
  padding: 8px 18px;
  font-weight: 600;
  font-size: 13px;
  border-radius: 6px;
  cursor: pointer;
}
.actions button.on {
  color: #fff;
  background: #008ffb;
  border-color: #008ffb;
}
</style>

Treemap / Sunburst Morph in Angular

Using ApexCharts with Angular

This Treemap / Sunburst Morph example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private TREE: any = [
          {
            data: [
              {
                x: 'Engineering',
                y: 88,
                color: '#008FFB',
                children: [
                  { x: 'Platform', y: 34, color: '#008FFB' },
                  { x: 'Product', y: 30, color: '#29A1FC' },
                  { x: 'Data', y: 24, color: '#52B3FC' },
                ],
              },
              {
                x: 'Design',
                y: 34,
                color: '#00E396',
                children: [
                  { x: 'Research', y: 12, color: '#00E396' },
                  { x: 'Brand', y: 10, color: '#29E7A7' },
                  { x: 'Systems', y: 12, color: '#52ECB8' },
                ],
              },
              {
                x: 'Go to market',
                y: 52,
                color: '#FEB019',
                children: [
                  { x: 'Sales', y: 26, color: '#FEB019' },
                  { x: 'Marketing', y: 15, color: '#FEBD3E' },
                  { x: 'Support', y: 11, color: '#FEC963' },
                ],
              },
            ],
          },
        ];

  private LEAVES: any = [
          {
            data: this.TREE[0].data.reduce(function (acc, parent) {
              return acc.concat(
                parent.children.map(function (c) {
                  return { x: c.x, y: c.y }
                }),
              )
            }, []),
          },
        ];

  private LEAF_COLORS: any = this.TREE[0].data.reduce(function (acc, parent) {
          return acc.concat(
            parent.children.map(function (c) {
              return c.color
            }),
          )
        }, []);

  private wirePartitionToggle = (chart: any): any => {
          var buttons = [].slice.call(document.querySelectorAll('[data-view]'))
  
          function apply(view) {
            buttons.forEach(function (b) {
              b.className = b.getAttribute('data-view') === view ? 'on' : ''
            })
            chart.updateOptions({
              chart: { type: view === 'sunburst' ? 'sunburst' : 'treemap' },
              series: view === 'sunburst' ? this.TREE : this.LEAVES,
            })
          }
  
          buttons.forEach(function (b) {
            b.addEventListener('click', function () {
              apply(b.getAttribute('data-view'))
            })
          })
        };

  public chartOptions: Partial<ChartOptions> = {
          series: this.LEAVES,
          chart: {
            id: 'partition',
            type: 'treemap',
            width: 700,
            height: 460,
            toolbar: {
              show: false,
            },
            animations: {
              enabled: true,
              chartTypeMorph: {
                enabled: true,
                speed: 900,
              },
            },
          },
          colors: this.LEAF_COLORS,
          legend: {
            show: false,
          },
          dataLabels: {
            enabled: true,
            style: {
              fontSize: '12px',
            },
          },
          plotOptions: {
            treemap: {
              // One palette entry per tile, taken straight from the data above, so a
              // tile and the arc it becomes are the same colour. Shading is off because
              // it would recolour tiles by value and break that pairing.
              distributed: true,
              enableShades: false,
            },
            sunburst: {
              innerSize: '22%',
              borderRadius: 2,
              spacing: 1,
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.wirePartitionToggle(this.chart)

    function wirePartitionToggle(chart) {
            var buttons = [].slice.call(document.querySelectorAll('[data-view]'))

            function apply(view) {
              buttons.forEach(function (b) {
                b.className = b.getAttribute('data-view') === view ? 'on' : ''
              })
              this.chart.updateOptions({
                chart: { type: view === 'sunburst' ? 'sunburst' : 'treemap' },
                series: view === 'sunburst' ? this.TREE : this.LEAVES,
              })
            }

            buttons.forEach(function (b) {
              b.addEventListener('click', () => {
                apply(b.getAttribute('data-view'))
              })
            })
          }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}